﻿do
	local frame = CreateFrame("Frame")
	frame.myPetID = C_PetJournal.GetSummonedPetGUID()
	frame:RegisterEvent("COMPANION_UPDATE")

	local function OnUpdate(self, elapsed)
		local start, duration, enable = GetSpellCooldown(118301)
		if start == 0 and duration == 0 and enable == 1 then
			local petID = C_PetJournal.GetSummonedPetGUID()
			if petID ~= self.myPetID then
				C_PetJournal.SummonPetByGUID(self.myPetID or petID)
			else
				self.autoUpdates = nil
			end
		end
	end
	frame:SetScript("OnUpdate", OnUpdate)

	local function OnEvent(self, event, companionType)
		if companionType == "CRITTER" then
			if not self.autoUpdates then
				self.myPetID = C_PetJournal.GetSummonedPetGUID()
			end
		end
	end
	frame:SetScript("OnEvent", OnEvent)

	hooksecurefunc(C_PetJournal, "SetPetLoadOutInfo",
		function(slotIndex, petID)
			if slotIndex == 1 then
				if petID ~= frame.petID then
					frame.petID = petID
					frame.autoUpdates = true
				end
			end
		end
	)
end
